"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyDirectiveTransformers = exports.directiveTypeDefs = void 0;
const graphql_tag_1 = require("graphql-tag");
const auth_directive_1 = require("./graphql-directives/auth.directive");
const cache_directive_1 = require("./graphql-directives/cache.directive");
const has_ability_directive_1 = require("./graphql-directives/has-ability.directive");
exports.directiveTypeDefs = (0, graphql_tag_1.gql) `
    ${auth_directive_1.authDirectiveTypeDefs}
    ${has_ability_directive_1.hasAbilityDirectiveTypeDefs}
    ${cache_directive_1.cacheDirectiveTypeDefs}
`;
function applyDirectiveTransformers(schema, addons) {
    let directiveTransformers = (0, auth_directive_1.authDirective)((0, has_ability_directive_1.hasAbilityDirective)(schema));
    if (addons) {
        for (let index = 0; index < addons.length; index++) {
            const addon = addons[index];
            directiveTransformers = addon(directiveTransformers);
        }
    }
    return directiveTransformers;
}
exports.applyDirectiveTransformers = applyDirectiveTransformers;
//# sourceMappingURL=app-graphql-directive.js.map