import { ObjectSchema } from 'joi';
import { Algorithm, SignOptions } from 'jsonwebtoken';
import { TokenKind } from '../type';
export { Algorithm };
export declare abstract class AuthBaseToken<T> {
    protected readonly secret: string;
    protected readonly schema: ObjectSchema<T>;
    protected readonly signOptions: SignOptions;
    protected readonly kind: TokenKind;
    protected readonly extendedKind: TokenKind;
    constructor(secret: string, expiresIn: string | number, schema: ObjectSchema<T>, kind: TokenKind, extendedKind: TokenKind, algorithm?: Algorithm);
    sign(payload: T, expiresIn?: string | number | Date, notBefore?: string | number | Date): string;
    verify(token: string): T;
    protected static baseDecode<T>(token: string, kind: TokenKind, schema: ObjectSchema<T>): T;
    private static validate;
}
