import { Request } from 'express';
import { AuthToken, Rule } from './auth-type';
import { AuthBearerVerify } from './auth-type-verify';
import { AppDomain } from '../type';
export declare class AuthBearer {
    private static self;
    private identityUrl;
    private fnVerify;
    private serviceIdToken;
    private filter;
    private caches;
    private cacheMax;
    private cacheDuration;
    private constructor();
    static init(urlOrfnVerify: string | AuthBearerVerify, serviceIdToken: string, orgId: number, appDomain: AppDomain, productId: number, cacheMax: number, cacheDuration: number): AuthBearer;
    static term(): void;
    static get instance(): AuthBearer;
    static get isEnabled(): boolean;
    get serviceIdTokenInfo(): {
        token: string;
        orgId: number;
        appDomain: AppDomain;
        productId: number;
    };
    verifyIdToken(authToken: AuthToken, req: Request, flag: boolean, hasAbility: Rule): Promise<AuthToken>;
    private callVerifyIdToken;
    private validateIdToken;
}
