import { Request } from 'express';
import { AuthToken, AuthDirective, Rule } from './auth-type';
export declare function auth(req: Request, authDirective: AuthDirective): Promise<AuthToken>;
export declare function isAuthenticated(authToken: AuthToken): boolean;
export declare function hasAbility(authToken: AuthToken, rules: Rule | Rule[]): void;
export declare function getServiceIdTokenInfoString(): string;
export declare function getServiceIdTokenInfo(): {
    userId: number;
    userLogin: string;
    token: string;
    orgId: number;
    appDomain: import("..").AppDomain;
    productId: number;
};
export declare function getServiceIdTokenClaim(token?: string): import("./auth-id-token").AuthIdTokenClaim;
