/// <reference types="node" />
import { DomainEventMessage } from 'cm-schema-event';
import { DomainSchema, Registry } from './domain-schema';
import { DomainEventCodec } from './domain-event-codec';
import { DomainEventCipher } from './domain-event-cipher';
export declare class DomainEvent<T, M> {
    protected codec: DomainEventCodec<Buffer, Buffer>;
    protected schema: DomainSchema<T>;
    protected metadataSchema?: DomainSchema<M>;
    constructor(schema?: string | Record<string, any>, metadataSchema?: string | Record<string, any>, cipher?: DomainEventCipher, disableSchemaRegistry?: Registry | boolean | null);
    encode({ eventType, eventId, correlationId, correlationTopic, timestamp, body, metadata }: DomainEventMessage<T, M>): Promise<Buffer>;
    decode(encodedMessage: Buffer): Promise<DomainEventMessage<T, M>>;
    get schemaRegistryId(): string | number;
    get metadataSchemaRegistryId(): string | number;
}
