export type ModelFactoryTransformArgs<T = any> = (args: T, context: any, resolveInfo: any, isBrowse: boolean) => T;
export declare class GraphQLHelper {
    #private;
    static setMap(jsonObject: object): void;
    static fieldsSelection(info: any): any;
    static itemsFieldsSelection(info: any, entity: any): any;
    static requestQueryDSLAtResolverLevel(info: any): string;
    static requestSelectAtResolverLevel(info: any, withSelect?: boolean): any;
    static getResolvers(obj: object): any[];
    static loadSchemaFiles(finalGraphql: any, pathString: string, isExternal?: boolean): void;
}
export declare class ModelFactory {
    #private;
    private listOfApis;
    private type;
    private listToResolve;
    private readonly queryOperationStartsWith;
    private readonly queryOperationBrowseStartsWith;
    private readonly transformArgs?;
    private readonly QUERY_OPERATION_START_WITH;
    private readonly QUERY_OPERATION_BROWSE_START_WITH;
    query: {};
    mutation: {};
    constructor(listOfApis: any, type: string, listToResolve?: string[], queryOperationStartsWith?: string[], queryOperationBrowseStartsWith?: string[], transformArgs?: ModelFactoryTransformArgs);
    resolve(fn: (x: any, y: any) => Promise<any>, args: any, context: any, resolveInfo: any, isBrowse?: boolean): Promise<any>;
}
