"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.logResMiddleware = void 0;
const cm_libs_context_aware_logger_1 = require("cm-libs-context-aware-logger");
const cm_libs_utils_1 = require("cm-libs-utils");
function logResMiddleware(req, res, next) {
    const resEnd = res.end;
    const url = req.url;
    res.end = (...args) => {
        if (!req['logExcluded'] && req.body?.operationName !== 'IntrospectionQuery') {
            (0, cm_libs_context_aware_logger_1.log)(cm_libs_context_aware_logger_1.Level.CRITICAL, () => {
                const elapsed = req['start'] ? (0, cm_libs_utils_1.timeElapsed)(req['start']).toString() : '-';
                return `RES: ${req.method} ${url} ${res.statusCode}, elapsed: ${elapsed + ' ms'}`;
            });
        }
        return resEnd.apply(res, args);
    };
    return next();
}
exports.logResMiddleware = logResMiddleware;
//# sourceMappingURL=http-logger.js.map