"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const correlation_id_1 = __importDefault(require("correlation-id"));
const nanoid_1 = require("nanoid");
function correlationMiddleware(options) {
    const headerName = (options && options.header) || 'x-correlation-id';
    return (req, res, next) => {
        req.correlationId = correlation_id_1.default.getId;
        const id = req.get(headerName);
        if (id) {
            correlation_id_1.default.withId(id, next);
        }
        else {
            correlation_id_1.default.withId((0, nanoid_1.nanoid)(), next);
        }
    };
}
exports.default = correlationMiddleware;
correlationMiddleware.getId = correlation_id_1.default.getId;
//# sourceMappingURL=correlation.js.map