import Joi from 'joi';
import { AccessInfo } from '../auth';
export declare enum OrganizationAllow {
    PAIDChain = "PAIDChain",
    BANK = "BANK",
    APPLICANT = "APPLICANT"
}
export declare enum PAIDChainRole {
    MAKER = "MAKER",
    CHECKER = "CHECKER",
    APPROVER = "APPROVER",
    OFFICER = "OFFICER",
    MCH_MERCHANT_API = "MCH_MERCHANT_API"
}
export declare enum BankRole {
    MAKER = "MAKER",
    CHECKER = "CHECKER",
    APPROVER = "APPROVER",
    OFFICER = "OFFICER"
}
export declare enum Role {
    APPLICANT = "APPLICANT"
}
type AllRole = Role | PAIDChainRole | BankRole;
type functionArgs<T, R> = {
    thisObject: object;
    fn: (request: T, accessInfo?: AccessInfo) => Promise<any>;
    schema: Joi.ObjectSchema<T>;
    params: T;
    accessInfo?: AccessInfo;
};
export declare class Permission {
    private static readonly PAIDChainOrgCode;
    static readonly BankOrgCodePrefix: string;
    private static readonly IS_BANK_INFRA;
    static readonly DISABLE_AUTH_CHECK: boolean;
    static check(organizationAllows: OrganizationAllow[] | OrganizationAllow, accessInfo: AccessInfo): Role | PAIDChainRole | BankRole;
    private static ApplicationCheck;
    private static PAIDChainCheck;
    private static BankCheck;
    static executeFunctionWithRole<T, R>(actual: AllRole, expected: AllRole[] | AllRole, args: functionArgs<T, R>[] | functionArgs<T, R>): Promise<R>;
    private static loopEveryRoleAndCheck;
    static isBank(): boolean;
    static details(accessInfo: AccessInfo): {
        roleType: string;
        roleOrgCode: string;
        roleOrgId: number;
        remoteIp: string;
        isBankOrg: boolean;
        isPAIDChainOrg: boolean;
    };
}
export {};
