import { RESTDataSource, WillSendRequestOptions } from '@apollo/datasource-rest';
import type { KeyValueCache } from '@apollo/utils.keyvaluecache';
import { AccessInfo } from '../auth';
export declare abstract class BaseRESTDataSource extends RESTDataSource {
    protected readonly token: string;
    protected cache: KeyValueCache;
    constructor(options: {
        token: string;
        cache?: KeyValueCache;
    });
    willSendRequest(request: WillSendRequestOptions): void;
    protected invokeGraphqlWithCache(functionName: string, body: object, accessInfo?: AccessInfo, allowCache?: boolean, ttlSeconds?: number): Promise<any>;
    private invokeGraphql;
    protected invokeRestWithCache(functionName: string, path: string, body: object, accessInfo?: AccessInfo, allowCache?: boolean, ttlSeconds?: number): Promise<any>;
    private invokeRest;
}
