import { Schema } from 'avsc';
import { DomainEventMessage } from 'cm-schema-event';
import { DomainEventConsumer, DomainEventHandler, DomainEventProducer, ExceptionHandler } from '../domain-event';
export declare class BaseEventProducer<T, M = any> {
    protected producer: DomainEventProducer<T, M>;
    readonly schemaName: string;
    constructor(topics: string[], schema: Schema | Record<string, any>, metadataSchema?: string | Record<string, any>);
    term(): Promise<void>;
    protected publish(message: DomainEventMessage<T, M>, ignoreError?: boolean): Promise<import("kafkajs").RecordMetadata[]>;
    get topics(): string[];
    emit(body: T, ignoreError?: boolean, correlationId?: string, correlationTopic?: string, eventId?: string): Promise<import("kafkajs").RecordMetadata[]>;
}
export declare class BaseEventConsumer<T, M = any> {
    protected consumer: DomainEventConsumer<T, M>;
    constructor(topic: string, appendOrdinalIndex?: boolean);
    term(): Promise<void>;
    subscribe(handler: DomainEventHandler<T, M>, exceptionHandler?: ExceptionHandler<T, M>): Promise<void>;
}
