/// <reference types="node" />
import { Server } from 'net';
import { TcpBase } from './tcp-base';
export type TcpServerInitParams = {
    keepAliveInterval?: number;
    idleTimeout?: number;
};
export declare abstract class TcpServer<T> extends TcpBase<T> {
    protected server: Server;
    private _keepAliveInterval;
    private _idleTimeout;
    init(params: TcpServerInitParams): Promise<this>;
    term(): Promise<void>;
    run(port: number, hostname?: string): Promise<string>;
    protected get keepAliveInterval(): number;
    protected get idleTimeout(): number;
}
